public interface ICompare<T> where T : ICompare<T> {
  static abstract bool operator<=(T first, T second);
  static abstract bool operator>=(T first, T second);
}

public class Pet : ICompare<Pet> {
  public string Name { get; init; }
  public int Age { get; init; }

  public static bool operator<=(Pet first, Pet second) {
    return first.Age <= second.Age;
  }

  public static bool operator>=(Pet first, Pet second) {
    return first.Age >= second.Age;
  }

  public override string ToString() => $"{Name}";
}

Pet buddy = new Pet() { Name = "Buddy", Age = 5 };
Pet rover = new Pet() { Name = "Rover", Age = 2 };

Console.WriteLine(buddy <= rover);
Console.WriteLine(buddy >= rover);

